{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "filterbyname",
            "doc": "Filterbyname",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bbmap:38.90--he522d1c_1",
                    "id": "#bbmap-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "bbmap",
                            "version": [
                                "38.90"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/bbmap"
                            ]
                        }
                    ],
                    "id": "#bbmap-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "in=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/in"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "in2=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/in2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "include=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/include"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "names=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/names"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "out=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/out"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "out2=",
                        "separate": false
                    },
                    "id": "#filterbyname.cwl/out2"
                }
            ],
            "baseCommand": [
                "filterbyname.sh"
            ],
            "id": "#filterbyname.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "http://schema.org/codeRepository": "http://bowtie-bio.sourceforge.net/index.shtml",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out)"
                    },
                    "id": "#filterbyname.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.out2)"
                    },
                    "id": "#filterbyname.cwl/output2"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "BASH echo command",
            "label": "FastQC",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "coresMin": "$(inputs.threads)",
                    "class": "ResourceRequirement"
                }
            ],
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/fastqc:0.11.9--0",
                    "id": "#fastqc-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "fastqc",
                            "version": [
                                "0.11.9"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/fastqc"
                            ]
                        }
                    ],
                    "id": "#fastqc-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#fastqc.cwl/fastq"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-t"
                    },
                    "id": "#fastqc.cwl/threads"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.html"
                    },
                    "id": "#fastqc.cwl/out_html"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.zip"
                    },
                    "id": "#fastqc.cwl/out_zip"
                }
            ],
            "baseCommand": [
                "fastqc",
                "--outdir",
                ".",
                "--extract"
            ],
            "id": "#fastqc.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "contamination_detection",
            "doc": "This tools remove contamination using a Blast TSV file",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                },
                {
                    "dockerImageId": "cwl-ngs-workflows-cbb-transcriptome-contamination-detection:3.7",
                    "dockerFile": "# Base Image\nFROM quay.io/biocontainers/python:3.7\n\n# Metadata\nLABEL base.image=\"quay.io/biocontainers/python:3.7\"\nLABEL version=\"1\"\nLABEL software=\"Python3\"\nLABEL software.version=\"3.7\"\nLABEL description=\"Python based docker image\"\nLABEL tags=\"Python\"\n\n# Maintainer\nMAINTAINER Roberto Vera Alvarez <r78v10a07@gmail.com>\n\nUSER root\n# Adding Python packages\nRUN python -m pip install \\\n    biopython==1.79  \\\n    networkx==2.5.1 \\\n    pandas==1.2.4\n",
                    "class": "DockerRequirement"
                },
                {
                    "packages": [
                        {
                            "package": "pandas",
                            "version": [
                                "1.2.4"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/pandas"
                            ]
                        },
                        {
                            "package": "biopython",
                            "version": [
                                "1.79"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/biopython"
                            ]
                        },
                        {
                            "package": "networkx",
                            "version": [
                                "2.5.1"
                            ],
                            "specs": [
                                "https://anaconda.org/conda-forge/networkx"
                            ]
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ],
            "requirements": [
                {
                    "listing": [
                        {
                            "entryname": "script.py",
                            "entry": "import os\nimport sys\nimport pandas\nimport pickle\nimport networkx as nx\n\nblastdir = sys.argv[1]\ntax_pickle = sys.argv[2]\ntax_id = sys.argv[3]\noutput = sys.argv[4]\n\ndef successors(g, O):\n    \"\"\"\n    Extract ancestors nodes from an starting node\n    :param g: starting node name\n    :param O: Graph\n    :return: a set with node names\n    \"\"\"\n    result = {g}\n    for o in O.successors(g):\n        result.update(successors(o, O))\n    return result\n\ndef findNode(O, id):\n    nodes = [y for x,y in O.nodes(data=True) if y['id']==id]\n    if nodes:\n        a = \"\"\n        for i in nx.shortest_path(O, source=\"1\", target=id)[2:]:\n            ns = [y for x,y in O.nodes(data=True) if y['id']==i]\n            if ns:\n                if a:\n                    a += \"; \"\n                a += ns[0]['name']\n        return nodes[0], a\n    return None, None\n\ntax = pickle.load(open(tax_pickle, \"rb\"))\ntax_ids = [int(i) for i in successors(tax_id, tax)]\nprint('{} taxonomies IDs in the list'.format(len(tax_ids)))\n\nfiles = [f for dr, ds, files in os.walk(blastdir) for f in files if f.endswith('.tsv')]\nqueries = []\ncount = 0\ntotal = len(files)\nfor f in files:\n    count += 1\n    print('Processing file: {}/{}\\r'.format(count, total), end='')\n    df = pandas.read_csv(os.path.join(blastdir, f), sep='\\t', header=None)\n    queries.extend(df[~df[6].isin(tax_ids)][0].unique())\nqueries = set(queries)\nwith open(output, 'w') as f_cont:\n    for r in queries:\n        f_cont.write('{}\\n'.format(r))\nprint('Queries: {}'.format(len(queries)))\n"
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#filter-blastout-query.cwl/blastdir"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#filter-blastout-query.cwl/out"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#filter-blastout-query.cwl/tax_id"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#filter-blastout-query.cwl/tax_pickle"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out)"
                    },
                    "id": "#filter-blastout-query.cwl/output"
                }
            ],
            "baseCommand": [
                "python",
                "script.py"
            ],
            "id": "#filter-blastout-query.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": "This workflow clean up vectros from fastq files",
            "label": "FASTQ Vector Removal",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/blastdir"
                },
                {
                    "type": "File",
                    "id": "#main/fastq1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/fastq2"
                },
                {
                    "type": "int",
                    "id": "#main/tax_id"
                },
                {
                    "type": "File",
                    "id": "#main/tax_pickle"
                },
                {
                    "type": "int",
                    "id": "#main/threads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/create_clean_fastq/output",
                    "type": "File",
                    "id": "#main/fastq1_output"
                },
                {
                    "outputSource": "#main/create_clean_fastq/output2",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/fastq2_output"
                },
                {
                    "outputSource": "#main/fastqc1/out_html",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastqc1_html"
                },
                {
                    "outputSource": "#main/fastqc1/out_zip",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/fastqc1_zip"
                },
                {
                    "outputSource": "#main/fastqc2/out_html",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/fastqc2_html"
                },
                {
                    "outputSource": "#main/fastqc2/out_zip",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#main/fastqc2_zip"
                }
            ],
            "steps": [
                {
                    "label": "Get contaminated read IDs",
                    "run": "#filter-blastout-query.cwl",
                    "in": [
                        {
                            "source": "#main/blastdir",
                            "id": "#main/contaminated_reads/blastdir"
                        },
                        {
                            "default": "contaminated.ids",
                            "id": "#main/contaminated_reads/out"
                        },
                        {
                            "source": "#main/tax_id",
                            "id": "#main/contaminated_reads/tax_id"
                        },
                        {
                            "source": "#main/tax_pickle",
                            "id": "#main/contaminated_reads/tax_pickle"
                        }
                    ],
                    "out": [
                        "#main/contaminated_reads/output"
                    ],
                    "id": "#main/contaminated_reads"
                },
                {
                    "label": "Creates clean FASTQ",
                    "run": "#filterbyname.cwl",
                    "in": [
                        {
                            "source": "#main/fastq1",
                            "id": "#main/create_clean_fastq/in"
                        },
                        {
                            "source": "#main/fastq2",
                            "id": "#main/create_clean_fastq/in2"
                        },
                        {
                            "default": "f",
                            "id": "#main/create_clean_fastq/include"
                        },
                        {
                            "source": "#main/contaminated_reads/output",
                            "id": "#main/create_clean_fastq/names"
                        },
                        {
                            "valueFrom": "${\n   var nameroot = inputs.in.nameroot;\n   if (nameroot.endsWith(\".fastq\")){\n     nameroot = nameroot.replace(\".fastq\", \"\");\n   }else if (nameroot.endsWith(\".fq\")){\n     nameroot = nameroot.replace(\".fq\", \"\");\n   }\n   if (nameroot.endsWith(\"_1\")){\n     nameroot = nameroot.replace('_1', '_noCont_1.fastq.gz');\n   }else if (nameroot.includes(\"_R1_\")){\n     nameroot = nameroot.substring(1, nameroot.indexOf(\"_R1_\")) + '_noCont_1.fastq.gz';\n   } else{\n     nameroot = nameroot + '_noCont.fastq.gz';\n   }\n   return nameroot;\n}\n",
                            "id": "#main/create_clean_fastq/out"
                        },
                        {
                            "valueFrom": "${\n    if (inputs.in2 != null){\n       var nameroot = inputs.in2.nameroot;\n       if (nameroot.endsWith(\".fastq\")){\n         nameroot = nameroot.replace(\".fastq\", \"\");\n       }else if (nameroot.endsWith(\".fq\")){\n         nameroot = nameroot.replace(\".fq\", \"\");\n       }\n       if (nameroot.endsWith(\"_2\")){\n         nameroot = nameroot.replace('_2', '_noCont_2.fastq.gz');\n       }else if (nameroot.includes(\"_R2_\")){\n         nameroot = nameroot.substring(1, nameroot.indexOf(\"_R2_\")) + '_noCont_2.fastq.gz';\n       }\n       return nameroot;\n    }\n    return null;\n}\n",
                            "id": "#main/create_clean_fastq/out2"
                        }
                    ],
                    "out": [
                        "#main/create_clean_fastq/output",
                        "#main/create_clean_fastq/output2"
                    ],
                    "id": "#main/create_clean_fastq"
                },
                {
                    "run": "#fastqc.cwl",
                    "label": "fastqc",
                    "in": [
                        {
                            "source": "#main/create_clean_fastq/output",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/fastqc1/fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/fastqc1/threads"
                        }
                    ],
                    "out": [
                        "#main/fastqc1/out_html",
                        "#main/fastqc1/out_zip"
                    ],
                    "id": "#main/fastqc1"
                },
                {
                    "run": "#fastqc.cwl",
                    "when": "$(inputs.fastq[0] != null)",
                    "label": "fastqc",
                    "in": [
                        {
                            "source": "#main/create_clean_fastq/output2",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#main/fastqc2/fastq"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/fastqc2/threads"
                        }
                    ],
                    "out": [
                        "#main/fastqc2/out_html",
                        "#main/fastqc2/out_zip"
                    ],
                    "id": "#main/fastqc2"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.2",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ]
}
